from es import getUseridList,voicechat,addons,getuserid
from gamethread import queue

_voice = set()
_text = set()

class getPlayer(object):
    def __init__(self,userid):
        self.userid = getuserid(userid)
        if not self.userid:
            raise TypeError,"'%s' is a invalid userid."%userid

    def muteVoice(self):
        _voice.add(self.userid)

    def unmuteVoice(self):
        _voice.discard(self.userid)

    def existsVoice(self):
        return self.userid in _voice

    def muteText(self):
        _text.add(self.userid)

    def unmuteText(self):
        _text.discard(self.userid)

    def existsText(self):
        return self.userid in _text

def _tick():
    if len(_voice):
        for userid in getUseridList():
            for target in _voice:
                if target == userid:
                    continue
                voicechat("nolisten",userid,target)
                queue(voicechat,("nolisten",userid,target))

addons.registerTickListener(_tick)

def _chat(userid,text,teamonly):
    if userid in _text:
        return (0,0,0)
    return (userid,text,teamonly)

addons.registerSayFilter(_chat)

def _player_disconnect(ev):
    u = int(ev["userid"])
    _voice.discard(u)
    _text.discard(u)

addons.registerForEvent(__import__(__name__),"player_disconnect",_player_disconnect)
